; DropList
; A trigger to call up a list.
;
; Functions:
; 1. guiDrawDrop
; 2. guiShowDrop
; 3. guiHideDrop
;
; Comments:
;  The little arrow is ld'd to the buffer, so the three pixels to the right will be cleared.
;

DL_BigFont		equ	0
DL_Inverse		equ	1
DL_DropOnR		equ	2
DL_Showing		equ	3

guiShowDrop:
 inc hl
 inc hl
 set DL_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawDrop
guiHideDrop:
 inc hl
 inc hl
 res DL_Showing,(hl)
 dec hl
 dec hl
guiDrawDrop:
 ld de,pencol
 ldi
 ldi
 res fracDrawLFont,(iy+fontFlags)
 bit DL_BigFont,(hl)
 jr z,guiDrawDropSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawDropSmall:
 bit DL_Showing,(hl)
 jr z,guiEraseDrop
 res textInverse,(iy+textFlags)
 bit DL_Inverse,(hl)
 jr z,guiDrawDropNotInverse
 set textInverse,(iy+textFlags)
guiDrawDropNotInverse:
 bit DL_DropOnR,(hl)
 call z,guiDrawDropArrow
 push hl
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 call vputs2
 ld hl,pencol
 inc (hl)
 pop hl
 bit DL_DropOnR,(hl)
 call nz,guiDrawDropArrow
 res fracDrawLFont,(iy+fontFlags)
 res textinverse,(iy+textflags)
 ret
guiDrawDropArrow:
 push hl
 ld de,(pencol)
 inc d
 inc d
 ld bc,3*256+1
 ld ix,DropArrowSprite
 bit DL_Inverse,(hl)
 jr z,guiDrawDropArrowNotInv
 ld ix,DropArrowInvSprite
guiDrawDropArrowNotInv:
 ld a,12
 call guiDrawSprite
 B_CALL _grbufcpy
 ld hl,pencol
 ld a,7
 add a,(hl)
 ld (hl),a
 pop hl
 ret

guiEraseDrop:
 ld a,(hl)
 push af
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 call pixlen
 res fracDrawLFont,(iy+fontFlags)
 res plotLoc,(iy+plotFlags)
 ld a,6
 add a,c
 ld c,a
 ld hl,(pencol)
 push hl
 add hl,bc
 ex de,hl
 pop hl
 pop af
 bit DL_Inverse,a
 jr nz,guiEraseDropFill
 B_CALL _clearrect
 ret
guiEraseDropFill:
 B_CALL _fillrect
 ret

DropArrowSprite:
 db 11111000b
 db 01110000b
 db 00100000b

DropArrowInvSprite:
 db 00000111b
 db 10001111b
 db 11011111b

guiHandleDrop:
 push hl
 pop ix
 push de
 ld de,pencol
 ldi
 ldi
 pop de
 bit DL_Showing,(hl)
 ret z
 res fracDrawLFont,(iy+fontFlags)
 bit DL_BigFont,(hl)
 jr z,guiHandleDropSmall
 set fracDrawLFont,(iy+fontFlags)
guiHandleDropSmall:
 inc hl
 call pixlen
 res fracDrawLFont,(iy+fontFlags)
 res plotLoc,(iy+plotFlags)
 ld b,6
 bit DL_BigFont,(ix+2)
 jr z,guiHandleDropSmall2
 inc b
guiHandleDropSmall2:
 ld a,c
 add a,8
 ld c,a
 ld hl,(pencol)
 push hl
 add hl,bc
 pop bc
 call IsInRectangle
 ret c
 ld (guiDLPtr),ix
 ld l,(ix+3)
 ld h,(ix+4)
guiHandleDropKeyLoop:
 ld a,0ffh
 out (1),a
 ld a,0fdh
 out (1),a
 in a,(1)
 bit 0,a
 jr z,guiHandleDropKeyLoop
 ld a,0bfh
 out (1),a
 in a,(1)
 bit 5,a
 jr z,guiHandleDropKeyLoop
 push hl
 call guiShowList
 call guiHandleMouse
 pop hl
 push hl
 call guiHandleList
 pop hl
 push hl
 push af
 call guiHideList
 pop af
 pop hl
 jp c,guiHandleClickFinished	; clicked outside of list
 ld de,6
 add hl,de
 or a
 jr z,guiHandleDropSkip1
guihandleDropLoop1:
 call nextstr
 dec a
 jr nz,guihandleDropLoop1
guiHandleDropSkip1:
 push hl
 ld hl,(guiDLptr)
 call guiHideDrop
 pop hl
 ld ix,(guiDLptr)
 ld (ix+5),l
 ld (ix+6),h
 ld hl,(guiDLPtr)
 call guiShowDrop
 jp guiHandleClickFinished