; Options
; Multiple pieces of text, in rectangles, only one highlighted.
;
; Functions:
; 1. guiDrawOptions
; 2. guiShowOptions
; 3. guiHideOptions			
; 4. guiSetOption		Options are redrawn, and option specified by register "a" is now selected.
;
; Comments:
;  For guiSetOption, zero is the first option, one is the second, etc.
;

OP_BigFont		equ	0
OP_Inverse		equ	1
OP_Showing		equ	2

guiShowOptions:
 set OP_Showing,(hl)
 jr guiDrawOptions

guiHideOptions:
 res OP_Showing,(hl)
 jr guiDrawOptions

guiSetOption:
 inc hl
 inc hl
 ld (hl),a
 dec hl
 dec hl

guiDrawOptions:
 res plotLoc,(iy+plotflags)
 res fracDrawLFont,(iy+fontFlags)
 bit OP_BigFont,(hl)
 jr z,guiDrawOptionsSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawOptionsSmall:
 bit OP_Showing,(hl)
 jp z,guiEraseOptions
 res textinverse,(iy+textflags)
 bit OP_Inverse,(hl)
 jr z,guiDrawOptionsNotInverse
 set textInverse,(iy+textflags)
guiDrawOptionsNotInverse:
 push hl
 pop ix
 inc hl
 ld b,(hl)
 inc hl
 ld c,0
 inc hl
guiDrawOptionsLoop:
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ld l,a
 push de
 add hl,de
 ex de,hl
 pop hl
 push hl
 push de
 push bc
 push ix
 ld a,c
 cp (ix+2)
 jr nz,guiDrawOptionsBorder
 B_CALL _fillrect
 ld a,(flags+textflags)
 xor 1<<textinverse
 ld (flags+textflags),a
 jr guiDrawOptionsFill
guiDrawOptionsBorder:
 B_CALL _drawrectborderc
guiDrawOptionsFill:
 pop ix
 pop bc
 pop de
 pop hl
 bit OP_Inverse,(ix)
 jr z,guiDrawOptionsNoInvertRect
 push hl
 push de
 push bc
 push ix
 B_CALL _invertrect
 pop ix
 pop bc
 pop de
 pop hl
guiDrawOptionsNoInvertRect:
 ld a,h
 add a,d
 sra a
 sub 3
 ld h,a
 ld a,l
 add a,e
 sra a
 ld l,a
 inc l
 ld (pencol),hl
 pop hl
 inc hl
 push bc
 call centertext2
 pop bc
 ld a,c
 cp (ix+2)
 jr nz,guiDrawOptionsNoResInverse
 ld a,(flags+textflags)
 xor 1<<textinverse
 ld (flags+textflags),a
guiDrawOptionsNoResInverse:
 inc c
 djnz guiDrawOptionsLoop
 res fracDrawLFont,(iy+fontFlags)
 res textinverse,(iy+textflags)
 ret

guiEraseOptions:
 push hl
 pop ix
 inc hl
 ld b,(hl)
 inc hl
 inc hl
guiEraseOptionsLoop:
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ld l,a
 push de
 add hl,de
 ex de,hl
 pop hl
 push ix
 push bc
 bit OP_Inverse,(ix)
 jr nz,guiEraseOptionsFill
 B_CALL _clearrect
 jr guiEraseOptionsClear
guiEraseOptionsFill:
 B_CALL _fillrect
guiEraseOptionsClear:
 pop bc
 pop ix
 pop hl
 inc hl
 call nextstr
 djnz guiEraseOptionsLoop
 ret

guiHandleOptions:
 bit OP_Showing,(hl)
 ret z
 push hl
 pop ix
 inc hl
 ld b,(hl)
 ld c,b
 inc hl
 inc hl
 inc b
guiHandleOptionsNext:
 dec b
 ret z
 push bc
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ld l,a
 add hl,bc
 call IsInRectangle
 pop hl
 inc hl
 call nextstr
 pop bc
 jr c,guiHandleOptionsNext
 push ix
 pop hl
 ld a,c
 sub b
 call guiSetOption
 jp guiHandleClickFinished