; Paragraph
; Multiple lines of text.
;
; Functions:
; 1. guiDrawPara			Checks the PA_Showing bit, and either draws the text or clears it accordingly.
; 2. guiShowPara			Sets the PA_Showing bit, then calls guiDrawLabel
; 3. guiHidePara			Resets the PA_Showing bit, then calls guiDrawLabel
;
; Comments:
; If the PA_Inverse flag is set, then hiding the label will make it black, otherwise
;  it will clear to white.
;

PA_BigFont			equ	0
PA_Inverse			equ	1
PA_Centered			equ	2
PA_Showing			equ	3

guiShowPara:
 inc hl
 inc hl
 set PA_Showing,(hl)
 dec hl
 dec hl
 jr guiDrawPara
guiHidePara:
 inc hl
 inc hl
 res PA_Showing,(hl)
 dec hl
 dec hl

guiDrawPara:
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 res fracDrawLFont,(iy+fontFlags)
 bit PA_BigFont,(hl)
 jr z,guiDrawParaSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawParaSmall:
 bit PA_Showing,(hl)
 jr z,guiErasePara
 res textInverse,(iy+textFlags)
 bit PA_Inverse,(hl)
 jr z,guiDrawParaNotInverse
 set textinverse,(iy+textflags)
guiDrawParaNotInverse:
 bit PA_Centered,(hl)
 push af
 inc hl
 pop af
 push af
 call z,multilinetextL2
 pop af
 call nz,multilinetextC2
 res textinverse,(iy+textflags)
 res fracDrawLFont,(iy+fontFlags)
 ret
guiErasePara:
 res plotLoc,(iy+plotFlags)
 res bufferonly,(iy+plotflag3)
 push hl
 pop ix
 ld (pencol),de
 inc hl
 ld b,(hl)
 inc hl
guiEraseParaLoop:
 push bc
 call pixlen
 push hl
 ld hl,(pencol)
 push hl
 add hl,bc
 ex de,hl
 ld hl,penrow
 ld (hl),d
 inc (hl)
 pop hl
 bit PA_Centered,(ix)
 jr z,guiEraseParaLeft
 ld a,e
 sub l
 sra a
 neg
 push af
 add a,l
 ld l,a
 pop af
 add a,e
 ld e,a
guiEraseParaLeft:
 bit PA_Inverse,(ix)
 jr z,guiEraseParaNotInverse
 B_CALL _fillrect
 jr guiEraseParaInverse
guiEraseParaNotInverse:
 B_CALL _clearrect
guiEraseParaInverse:
 pop hl
 call nextstr
 pop bc
 djnz guiEraseParaLoop
 res fracDrawLFont,(iy+fontFlags)
 ret

guiHandlePara:
 ret
; I'm too lazy to actually bother checking if it was clicked (ie. it's lots of work)
; and clicking it would do nothing, so I'll just not do anything and let the other
; things figure out that they weren't clicked.

